#! /usr/bin/perl

# ================================================================== #
#  Fumy News Clipper Ver 2.00 - Hitokoto Bookmarks -   [fumyxml.pl]  #
# ================================================================== #
#  Copyright (C) Fumihiro-Nishimura.(Nishishi) 2006.                 #
#                                                                    #
#  hb.cgipȈXMLҏWCu                                     #
#                                                                    #
#  ̃t@Cɐݒ荀ڂ͂܂B̂܂܎gĉB      #
#                                                                    #
#  http://www.nishishi.com/                                          #
# ================================================================== #

package fumyxmlpackage;

# ------------- #	OĂяo
# XML̓ǂݍ #	F XMLt@C, ovf
# ------------- #	ԒlF XMLg̔zi1vf1R[hj
sub XMLin
{
	my $filename = shift @_;
	my $element  = shift @_;
	my @data;

	open XML, $filename;
	foreach my $onerec (<XML>) {
		if( $onerec =~ m|<$element>.*</$element>| ) {
			# wvf̂郌R[hΒo
			push( @data, $onerec );
		}
	}
	close XML;

	return @data;
}

# ------------- #	OĂяo
# XML̏o #	F XMLt@C, Jo[vf, R[h, gz
# ------------- #	ԒlF Ȃ
sub XMLout
{
	my $filename = shift @_;
	my $coverelement = shift @_;
	my $charcode = shift @_;
	my @outputXML = @_;

	# ]vȋ󔒂Ɖs菜
	# `̂߂Ƀ^u}
	foreach my $onerec ( @outputXML ) {
		$onerec =~ s|^\s*(.+)\n*$|$1|;
		$onerec = "	$onerec\n";
	}

	# wb_ƍŏKwvfǉ
	unshift( @outputXML, "<$coverelement>\n" );
	unshift( @outputXML, qq(<?xml version="1.0" encoding="$charcode" ?>\n) );
	push( @outputXML, "</$coverelement>\n" );

	# t@Co
	open OUT, "> $filename";
	print OUT @outputXML;
	close OUT;
}

# -------------- #	OĂяo
# e̔o #	F , ovf
# -------------- #	ԒlF vf̕
sub getcontent
{
	my $xmlstring = shift @_;
	my $element   = shift @_;

	if( $xmlstring =~ m|<$element>(.*)</$element>| ) {
		return $1;
	}
	return '';
}

# -------------- #	OĂяo
# R[h̍쐬 #	F R[hvf, g̗vf(z)
# -------------- #	ԒlF R[h
sub makerecord
{
	my $recelement = shift @_;
	my $ret = "<$recelement>";

	foreach my $one (@_) {
		$ret .= $one;
	}
	$ret .= "</$recelement>";

	return $ret;
}

# ---------- #	OĂяo
# vf̍쐬 #	F vf, g, IvV
# ---------- #	ԒlF vf
sub makeelement
{
	my $elementname	= shift @_;
	my $content		= shift @_;
	my $allowand	= shift @_;
	my $allowtag	= shift @_;

	$content = &content_encode($content,$allowand,$allowtag);

	return qq|<$elementname>$content</$elementname>|;
}

# ---------------- #	
# L^pGR[h #	F , IvV
# ---------------- #	ԒlF GR[h㕶
sub content_encode
{
	my $string 		= shift @_;
	my $allowand	= shift @_ || 0;
	my $allowtag	= shift @_ || 0;
	my $ret;

	# GR[hi̎QƂւ̕ϊɍsKvj
	if( $allowand == 0 ) {
		$string =~ s|&|&amp;|g;		# Ah̎QƂ
	}
	if( $allowtag == 0 ) {
		$string =~ s|<|&lt;|g;		# Ȃ̎QƂ
		$string =~ s|>|&gt;|g;		# Ȃ̎QƂ
	}

	$string =~ s|\r\n|<br />|g;		# s(CRLF)^O
	$string =~ s|\n|<br />|g;		# s(CR)^O
	$string =~ s|\r|<br />|g;		# s(LF)^O

#		$string =~ s|\&lt;a(\s+.*)href="(.+)"(.*)\&gt;(.*)\&lt;/a&gt;|<a$1 href="$2"$3>$4</a>|ig;		# N

	$ret = $string;

	return $ret;
}

# -------------- #	
# L^pfR[h #	F 
# -------------- #	ԒlF GR[h㕶
sub content_decode
{
	my $string = shift @_;
	my $ret;

	# fR[hi̎QƂ̓WJ͕svFWJƃ}ŶŒӁj
	$string =~ s|<br />|\n|g;		# s^OsR[h

	# S΍F̓tH[HTMLĂ܂͋IɎ̎QƂɕϊiL^eɉeȂΖȂB܂A̓tH[̒lɎgɂ͖ȂBj
	$string =~ s|<|&lt;|g;		# ^OŕKvȗvfÎj~FȂ̎QƂ
	$string =~ s|>|&gt;|g;		# ^OŕKvȗvfÎj~FȂ̎QƂ
	$string =~ s|"|&quot;|g;	# inputvf̒l̏Ij~

	$ret = $string;

	return $ret;
}

#print qq|Content-Type: text/html; charset=Shift_JIS\n\n|;
#print qq|fumyxml.pl|;

1;
